<script>
import Icon from "@/components/Icon/index";
import {
    EditorMenuBar
} from "tiptap";
export default {
    props: {
        editor: {
            type: [Object, Array],
            default: () => [],
        },
        tool: {
            type: [Object, Array],
            default: () => [],
        },
    },
    components: {
        Icon,
        EditorMenuBar,
    },
    render(h) {
        let vm = this;
        let bar = h(EditorMenuBar, {
            props: {
                editor: this.editor,
            },
            scopedSlots: {
                default: function ({
                    commands,
                    isActive,
                    focused
                }) {
                    return h(
                        "div", {
                            class: {
                                "is-focused": focused,
                                //"is-focused": true,
                                menubar: true,
                                    "is-hidden": true,
                            },
                        },
                        vm.tool.map((item) => {
                            if (typeof item != "object") {
                                let ISACTIVE = isActive[item] ? isActive[item]() : false;
                                return h(
                                    "button", {
                                        class: {
                                            menubar__button: true,
                                                "is-active": ISACTIVE,
                                        },
                                        on: {
                                            click() {
                                                commands[item]();
                                            },
                                        },
                                    },
                                    [
                                        h(Icon, {
                                            props: {
                                                name: item + "_tiptap",
                                            },
                                        }),
                                    ]
                                );
                            } else {
                                return item.heading.map((Htag) => {
                                    return h(
                                        "button", {
                                            class: {
                                                menubar__button: true,
                                                    "is-active": isActive.heading({
                                                        level: Htag,
                                                    }),
                                            },
                                            on: {
                                                click() {
                                                    commands.heading({
                                                        level: Htag,
                                                    });
                                                },
                                            },
                                        },
                                        ["H" + Htag]
                                    );
                                });
                            }
                        })
                    );
                },
            },
        });
        return bar;
    },
};
</script>

<style lang="scss">
$color-black: #000000;
$color-white: #ffffff;
$color-grey: #dddddd;

.menubar {
    position: absolute;
    top: -47%;
    left: 50%;
    transform: translateX(-50%);
    margin-bottom: 1rem;
    transition: visibility 0.2s 0.4s, opacity 0.2s 0.4s;
    width: 61%;
    background-color: #ffffff;
    border: 1px solid rgba(0, 0, 0, 0.125);
    border-radius: 2px;
    box-shadow: 1px 1px 5px rgba(0, 0, 0, 0.125);
    padding: 0 5px 3px;
    z-index: 12;

    &.is-hidden {
        visibility: hidden;
        opacity: 0;
    }

    &.is-focused {
        visibility: visible;
        opacity: 1;
        transition: visibility 0.2s, opacity 0.2s;
    }

    &__button {
        font-weight: bold;
        display: inline-flex;
        background: transparent;
        border: 0;
        color: $color-black;
        padding: 0.2rem 0.5rem;
        margin-right: 0.2rem;
        border-radius: 3px;
        cursor: pointer;
        font-size: 13px;
        line-height: 1;

        &:hover {
            background-color: rgba($color-black, 0.05);
        }

        &.is-active {
            background-color: rgba($color-black, 0.1);
        }
    }

    span#{&}__button {
        font-size: 13.3333px;
    }
}
</style>
